import numpy

IGNORE_0 = False

class GameField(object):
    """Coordinates in format (y, x)!!"""
    def __init__(self, field=None, suppllies=None, file=None, AI=False):
        self.points = 0
        if file is None:
            self.field = field
            self.suppllies = suppllies
        else:
            if not AI:
                self.field = []
                self.suppllies = []
                with open(file, "r") as f:
                    lines = f.readlines()
                    for i in range(8):
                        tmp = []
                        nums = list(lines[i])
                        for i in nums:
                            try:
                                tmp.append(int(i))
                            except:
                                pass
                        self.field.append(tmp)
                    for i in range(8,16):
                        tmp = []
                        nums = list(lines[i])
                        for i in nums:
                            try:
                                tmp.append(int(i))
                            except:
                                pass
                        self.suppllies.append(tmp)
            else:
                self.field = []
                with open(file, "r") as f:
                    lines = f.readlines()
                    for i in range(1,9):
                        tmp = []
                        nums = list(lines[i])
                        for i in nums:
                            try:
                                tmp.append(int(i))
                            except:
                                pass
                        self.field.append(tmp)

    def search_for_moves(self):
        """Search for availible moves

        The Field HAVE TO be WITHOUT matches!

        txpe:    ?  ?
            0 - ?.11.?
                 ?  ?

                 ?
            1 - 1.1
                 ?
        """
        moves = []
        for y in range(8):
            for x in range(8):
                tmp = self.field[y][x]
                if tmp == 0 and IGNORE_0:
                    continue
                if self.check_if_match(y+1, x, tmp):
                    moves += self.filter_out_None_is_in_neighborhood((y, x, 0))
                if self.check_if_match(y+2, x, tmp):
                    moves += self.filter_out_None_is_in_neighborhood((y, x, 1))
                if self.check_if_match(y, x+1, tmp):
                    moves += self.filter_out_None_is_in_neighborhood((y, x, 2))
                if self.check_if_match(y, x+2, tmp):
                    moves += self.filter_out_None_is_in_neighborhood((y, x, 3))
        return moves

    def is_in_neighborhood(self, tuple_):
        def check_up(y, x):
            if self.check_if_match(y-1, x, match):
                return ((y, x), (y-1, x))
            return None
        def check_down(y, x):
            if self.check_if_match(y+1, x, match):
                return ((y, x), (y+1, x))
            return None
        def check_left(y, x):
            if self.check_if_match(y, x-1, match):
                return ((y, x), (y, x-1))
            else:
                return None
        def check_right(y, x):
            if self.check_if_match(y, x+1, match):
                return ((y, x), (y, x+1))
            else:
                return None
        def check_up_down(y, x):
            return (check_up(y, x), check_down(y, x))
        def check_left_right(y, x):
            return (check_left(y, x), check_right(y, x))
        def check_up_down_left(y, x):
            return check_up_down(y, x) + (check_left(y, x),)
        def check_up_down_right(y, x):
            return check_up_down(y, x) + (check_right(y, x),)
        def check_left_right_up(y, x):
            return check_left_right(y, x) + (check_up(y, x),)
        def check_left_right_down(y, x):
            return check_left_right(y, x) + (check_down(y, x),)
        y, x, type_ = tuple_
        match = self.field[y][x]
        if type_ == 0:
            return check_left_right_up(y-1, x) + check_left_right_down(y+2, x)
        elif type_  == 1:
            return check_left_right(y+1, x)
        elif type_  == 2:
            return check_up_down_left(y, x-1) + check_up_down_right(y, x+2)
        elif type_  == 3:
            return check_up_down(y, x+1)

    def filter_out_None_is_in_neighborhood(self, tuple_):
        out = []
        for i in self.is_in_neighborhood(tuple_):
            if i is not None:
                out.append(i)
        return out

    def check_if_match(self, y, x, match):
        if 0 <= y < 8 and 0 <= x < 8:
            if self.field[y][x] == match:
                return True
        return False


    def count_matches(self):
        out = 0
        for y in range(8):
            for x in range(8):
                tmp = self.field[y][x]
                if tmp == 0 and IGNORE_0:
                    continue
                if self.check_if_match(y+1, x, tmp) and self.check_if_match(y+2, x, tmp):
                    out += 1
                if self.check_if_match(y, x+1, tmp) and self.check_if_match(y, x+2, tmp):
                    out +=1
        return out

    def count_points(self, matches=None):
        if matches is None:
            matches = self.get_matches()
        out = 0
        for match in matches:
            for stone in match:
                out += 1
        return out

    def get_stones_to_remove(self, matches=None):
        if matches is None:
            matches = self.get_matches()
        out = set()
        for match in matches:
            for stone in match:
                out.add(stone)
        out = list(out)
        out.sort()
        return out

    def remove_stones(self, stones=None, matches=None):
        if stones is None:
            stones = self.get_stones_to_remove(matches)
        for i in stones:
            self.remove_stone(i)

    def remove_stone(self, pos):
        for y in range(pos[0], 0, -1):
            self.field[y][pos[1]] = self.field[y-1][pos[1]]
        try:
            self.field[0][pos[1]] = self.suppllies[pos[1]].pop(0)
        except:
            self.field[0][pos[1]] = None

    def get_matches(self):
        out = []
        for y in range(8):
            for x in range(8):
                tmp = self.field[y][x]
                if tmp == 0 and IGNORE_0:
                    continue
                if self.check_if_match(y+1, x, tmp) and self.check_if_match(y+2, x, tmp):
                    out.append([(y, x), (y+1, x), (y+2, x)])
                if self.check_if_match(y, x+1, tmp) and self.check_if_match(y, x+2, tmp):
                    out.append([(y, x), (y, x+1), (y, x+2)])
        return out

    def move(self, move):
        self.field[move[0][0]][move[0][1]], self.field[move[1][0]][move[1][1]] = self.field[move[1][0]][move[1][1]], self.field[move[0][0]][move[0][1]]
        matches = self.get_matches()
        self.points += self.count_points(matches)
        self.remove_stones(matches=matches)

    def __str__(self):
        out = ""
        for y in range(8):
            for x in range(8):
                out += str(self.field[y][x]) + " "
            out += "\n"
        return out

    def save(self, file, move):
        with open(file, "w") as f:
            f.write(str(move[0][1]+1) + " " + str(move[0][0]+1) + " " + str(move[1][1]+1) + " " + str(move[1][0]+1) )

def search_in_moves(moves, pos):
    for i in moves:
        if i[1] == pos:
            return True
    return False

def match_move(moves, pos):
    for i in moves:
        if i == pos:
            return True
    return False

if __name__ == '__main__':
    IGNORE_0 = True
    field = numpy.array([[0]*8]*8)
    field[0][1] = 1
    field[2][1] = 1
    field[3][1] = 1
    suppllies = [[8, 7, 6, 5, 4, 3, 2, 1], [8, 7, 6, 5, 4, 3, 2, 1],
                 [8, 7, 6, 5, 4, 3, 2, 1], [8, 7, 6, 5, 4, 3, 2, 1],
                 [8, 7, 6, 5, 4, 3, 2, 1], [8, 7, 6, 5, 4, 3, 2, 1],
                 [8, 7, 6, 5, 4, 3, 2, 1], [8, 7, 6, 5, 4, 3, 2, 1]]
    g = GameField(field, suppllies)
    #g = GameField(file="checker.txt")
    #print("MATCHES:", g.count_matches())
    #print("COORDS OF MATCHES:", g.get_matches())
    #print("POINTS:", g.count_points())
    print("MAP:")
    #print("STONES TO REMOVE:", g.get_stones_to_remove())
    print(g)
    print("AVAILIBLE MOVES:", g.search_for_moves())
    #print(g.suppllies)
    #print(search_in_moves(g.search_for_moves(), (0,0)))
    #print(search_in_moves(g.search_for_moves(), (5,5)))
    #g.remove_stones()
