#! /bin/env python3
import random, pygame, sys
from pygame.locals import *
import game, time
FPS = 30 # frames per second, the general speed of the program
WINDOWWIDTH = 800 # size of window's width in pixels
WINDOWHEIGHT = 910 # size of windows' height in pixels
Game = None

#            R    G    B
GRAY     = (100, 100, 100)
NAVYBLUE = ( 60,  60, 100)
WHITE    = (255, 255, 255)
RED      = (255,   0,   0)
GREEN    = (  0, 255,   0)
BLUE     = (  0,   0, 255)
YELLOW   = (255, 255,   0)
ORANGE   = (255, 128,   0)
PURPLE   = (255,   0, 255)
CYAN     = (  0, 255, 255)
BLACK    = (  0,   0,   0)

DICT = {
    1: RED,
    2: GREEN,
    3: BLUE,
    4: WHITE,
    5: YELLOW,
    6: PURPLE,
}

def main():
    global FPSCLOCK, DISPLAYSURF, Game, end
    pygame.init()
    FPSCLOCK = pygame.time.Clock()
    DISPLAYSURF = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT))
    pygame.display.set_caption('Jewels')

    fontObj = pygame.font.Font('freesansbold.ttf', 80)
    fontObjSC = pygame.font.Font('freesansbold.ttf', 20)

    selection = None

    scoreSurf = None
    scoreRect = None
    #SCORE
    def genScore():
        STR = "SCORE: " + str(Game.points)
        scoreSurf = fontObjSC.render( STR,  True, GREEN, WHITE)
        scoreRect = scoreSurf.get_rect()
        scoreRect.x = 0
        scoreRect.y = 0
        return scoreSurf, scoreRect
    scoreSurf, scoreRect = genScore()

    END = False
    outSurf = None
    outRect = None
    def genOUT():
        if end == None:
            STR = "KONEC HRY " + str(Game.points) + "p"
        else:
            STR = "CAS VYPRSEL " + str(Game.points) + "p"
        outSurf = fontObj.render( STR,  True, RED, WHITE)
        outRect = scoreSurf.get_rect()
        surf = DISPLAYSURF.get_rect()
        outRect.centery = surf.centery
        outRect.left = 100
        return outSurf, outRect

    moves = Game.search_for_moves()
    if len(moves) == 0:
        END = True
        outSurf, outRect = genOUT()

    while True:
        DISPLAYSURF.fill(BLACK)

        for i in range(8):
            try:
                pygame.draw.rect(DISPLAYSURF, DICT[Game.suppllies[i][0]], (i*100, 0, 100, 100))
            except:
                pass

        for y in range(8):
            for x in range(8):
                pygame.draw.rect(DISPLAYSURF, DICT[Game.field[y][x]], (x*100, y*100+120, 100, 100))

        mouse_pos = pygame.mouse.get_pos()
        if mouse_pos[1] > 120:
            x, y = mouse_pos[0] // 100, (mouse_pos[1]-120) // 100
            if game.search_in_moves(moves, (y, x)):
                cursor = WHITE
            else:
                cursor = RED
            pygame.draw.rect(DISPLAYSURF, BLACK, (x*100, y*100+120, 100, 100), 5)
            pygame.draw.rect(DISPLAYSURF, cursor, (x*100, y*100+120, 98, 98), 2)

        if selection:
            pygame.draw.rect(DISPLAYSURF, BLACK, (selection[0]*100, selection[1]*100+120, 100, 100), 5)
            pygame.draw.rect(DISPLAYSURF, GREEN, (selection[0]*100, selection[1]*100+120, 98, 98), 2)

        DISPLAYSURF.blit(scoreSurf, scoreRect)
        if END: DISPLAYSURF.blit(outSurf, outRect)
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.MOUSEBUTTONUP and not END:
                x, y = mouse_pos[0] // 100, (mouse_pos[1]-120) // 100
                if selection is None:
                    if game.search_in_moves(moves, (y, x)):
                        selection = (x, y)
                else:
                    if game.match_move(moves, ((y, x), (selection[1], selection[0]))):
                        Game.move(((y, x), (selection[1], selection[0])))
                        scoreSurf, scoreRect = genScore()
                        moves = Game.search_for_moves()
                        if len(moves) == 0:
                            END = True
                            outSurf, outRect = genOUT()
                        selection = None
                    else:
                        selection = None

        if end:
            if time.time() > end:
                END = True
                end = True
                outSurf, outRect = genOUT()

        pygame.display.update()

Game = game.GameField(file=input("File name: "))
#Game = game.GameField(file="checker.txt")
ti = input("ENTER TIME IN FORMAT(mm:ss): ")
if ti != "":
    mm, ss = ti.split(":")
    end = time.time() + int(mm) * 60 + int(ss)
else:
    end = None
main()
